# cython: boundscheck=False, wraparound=False, nonecheck=False, cdivision=True
import cython
import numpy as np
cimport numpy as np

from libc.math cimport sin, pow

cdef inline rhs_f(double t,double y):
	return -0.5*sin(pow(y,2))

cpdef heun(int nt, double y0, double t0, double h):
	cdef double[:] y_arr = np.empty( nt + 1, dtype="double" )
	cdef double[:] t_arr = np.empty( nt + 1, dtype="double" )
	cdef double y_temp
	cdef int i
	y_arr[0] = y0
	t_arr[0] = t0
	for i in range(0, nt):
		t_arr[i+1] = t0 + float(i+1)*h
		y_temp = y_arr[i] + h * rhs_f(t_arr[i], y_arr[i])
		y_arr[i+1] = y_arr[i] + h/2.0 * ( rhs_f(t_arr[i],y_arr[i]) + rhs_f(t_arr[i+1], y_temp) )
	return np.asarray(y_arr), np.asarray(t_arr)

