# A ODE solver with numpy and Cython
# Author: Nicholas Danes
from rk2_cython import heun
import numpy as np
# initial time
t0 = 0.0

# final time
tfinal = 1000.0

# number of time steps
nt = np.loadtxt('nt.txt', dtype=int)

# step size
h = (tfinal-t0)/float(nt)
y0 = 1.0

def main():
	y_sol, t_sol = heun(nt, y0, t0, h)

if __name__ == "__main__":
	main()

