# A pure python ODE solver without numpy
# Author: Nicholas Danes
import math

# initial time
t0 = 0.0

# final time
tfinal = 1000.0

# number of time steps
from numpy import loadtxt
nt = loadtxt("nt.txt", dtype=int)

# step size
h = (tfinal-t0)/float(nt)
print(h)
y0 = 1.0
def rhs_f(t,y):
	return -0.5*math.sin(math.pow(y,2))

def heun(rhs):
	y_arr = [] # defines a list for y_arr
	t_arr = [] # defines a list for t_arr
	y_prev = y0
	t_prev = t0
	y_arr.append(y0)
	t_arr.append(t0)
	for i in range(0, nt):
		t_curr = t0 + float(i+1)*h
		y_temp = y_prev + h * rhs(t_prev, y_prev)
		y = y_prev + h/2.0 * ( rhs(t_prev,y_prev) + rhs(t_curr, y_temp) )
		y_prev = y
		t_prev = t_curr
		y_arr.append(y)
		t_arr.append(t_curr)

	return y_arr, t_arr

def main():
	y_sol, t_sol = heun(rhs_f)

if __name__ == "__main__":
    main()

